#ifndef _PAERR_H
#define _PAERR_H

	/*Normal*/
#define ERR_OK			 0	/* No error */

	/*Operation control section (PA library) detection error:*/
#define ERR_FILE		-1	/* Designated file not existing*/
#define	ERR_READ		-2 	/* File loading failure*/
#define	ERR_WRITE		-3 	/* File saving failure**/
#define ERR_INT			-4	/* Unsuccessful interruption into 486*/
#define ERR_OPEN		-5	/* pa_opn_arm() not executed*/

	/*װ*/
#define ERR_ARM			-20	/* Designated arm not existing*/
#define ERR_AXIS		-21	/* Designated axis not existing*/
#define ERR_DRV			-22	/* Designated driver not existing*/
#define ERR_PB			-23	/* Incorrect playback motion mode*/
#define ERR_PD			-24	/* Incorrect teach point deletion mode*/
#define ERR_PA			-25	/* Incorrect teach point attribution mode*/
#define ERR_PTN			-26	/* Incorrect teach point velocity pattern attribution value*/
#define ERR_PT			-27	/* Incorrect teach point data type*/
#define ERR_PM			-28	/* Incorrect teach point operation type*/
#define ERR_VT			-29	/* Incorrect default velocity alteration type*/
#define ERR_VM			-30	/* Incorrect velocity control mode*/
#define ERR_JM			-31	/* Incorrect redundant axis control mode*/
#define ERR_JT			-32	/* Incorrect redundant axis operation mode*/
#define ERR_MM			-33	/* Incorrect target tip matrix control mode*/
#define ERR_DM			-34	/* Incorrect direct control mode*/
#define ERR_DP			-35	/* Incorrect digital input/output port designation*/
#define ERR_DC			-36	/* Incorrect digital input/output channel designation*/
#define ERR_MES			-37	/* Error code not defined*/

	/*EWarning error:*/

#define	ERR_CANT_CPU	-1000	  /*Access to motion controller not allowed.*/
#define	ERR_NON_EVNT	-1001	  /*Format does not match with command.*/ 
#define	ERR_CANT_EVNT	-1002	  /*Command not compatible with current mode*/
#define	ERR_INVALD_EVNT	-1003	  /*Invalid command*/

#define	ERR_S1_VEL		-1010	  /*S1 axis velocity exceeded*/
#define	ERR_S2_VEL		-1011	  /*S2 axis velocity exceeded*/
#define	ERR_S3_VEL		-1012	  /*S3 axis velocity exceeded*/
#define	ERR_E1_VEL		-1013	  /*E1 axis velocity exceeded*/
#define	ERR_E2_VEL		-1014	  /*E2 axis velocity exceeded*/
#define	ERR_W1_VEL		-1015	  /*W1 axis velocity exceeded*/
#define	ERR_W2_VEL		-1016	  /*W2 axis velocity exceeded*/

#define	ERR_XYZ_VEL		-1018	  /*Tip linear velocity exceeded */
#define	ERR_YPR_VEL		-1019	  /*Tip rotational velocity exceeded */

#define	ERR_S1_SAGL		-1020	  /*S1 axis safety angle exceeded*/
#define	ERR_S2_SAGL		-1021	  /*S2 axis safety angle exceeded*/
#define	ERR_S3_SAGL		-1022	  /*S3 axis safety angle exceeded*/
#define	ERR_E1_SAGL		-1023	  /*E1 axis safety angle exceeded*/
#define	ERR_E2_SAGL		-1024	  /*E2 axis safety angle exceeded*/
#define	ERR_W1_SAGL		-1025 	  /*W1 axis safety angle exceeded*/
#define	ERR_W2_SAGL		-1026	  /*W2 axis safety angle exceeded*/
							/*=== Ver.1.3 ====*/
#define	ERR_S1_TAGL		-1030	  /*S1 axis target angle exceeded*/
#define	ERR_S2_TAGL		-1031	  /*S2 axis target angle exceeded*/
#define	ERR_S3_TAGL		-1032	  /*S3 axis target angle exceeded*/
#define	ERR_E1_TAGL		-1033	  /*E1 axis target angle exceeded*/
#define	ERR_E2_TAGL		-1034	  /*E2 axis target angle exceeded*/
#define	ERR_W1_TAGL		-1035	  /*W1 axis target angle exceeded*/
#define	ERR_W2_TAGL		-1036	  /*W2 axis target angle exceeded*/
							/*===============*/

#define	ERR_LNK_CTL		-1039	  /*Unable to create teach point due to continuity restriction Ver.1.3*/
#define	ERR_MEM_FULL	-1040	  /*Failed to allocate memory space */
#define	ERR_MIS_COMD	-1041	  /*Prior procedure required before issuing this command */
#define	ERR_PB_CIR		-1042	  /*Incorrect circle or arc designation*/
#define	ERR_PB_NEXT		-1043	  /*Next pointer not existing*/
#define	ERR_PB_PRIV		-1044	  /*Previous pointer not existing*/
#define	ERR_PB_END		-1045	  /*Playback data ended*/
#define	ERR_PB_NULL		-1046	  /*Playback data not existing*/
#define	ERR_PB_REFER	-1047	  /*Failed to find playback data*/
#define	ERR_PB_REPLACE	-1048	  /*Accepted as replace command*/
#define	ERR_PB_PANIC	-1049	  /*Pointer management accident*/

#define	ERR_NOT_ENUGH	-1050	  /*Target value is out of control area. 
				                  (Arm length is not enough.) */
#define	ERR_MIS_PARAM	-1051	  /*Designated parameter value exceeded the setting range*/
#define	ERR_NOA_DAT		-1060	  /*Designated NOA not appropriate Ver.1.3*/
#define	ERR_PNT_ATR		-1061	  /*Not available Ver.1.3*/
#define	ERR_PTP_DAT		-1062	  /*Exceeding RMRC motion range Ver.1.3*/
#define	ERR_CP_LOGGING	-1063	  /*Not allowed to use while in CP data acquisition Ver.1.3*/
#define	ERR_FIFO_MAX	-1064	  /*Exceeded the maximum interpolation number@Ver.1.3*/
#define	ERR_FIFO_ARC	-1065	  /*axis velocity angle exceeded@Ver.1.3*/
							/*=== Ver.1.3 ====*/
#define	COVERS1			-1070	  /*S1 axis velocity angle exceeded*/
#define	COVERS2    		-1071	  /*S2 axis velocity angle exceeded*/
#define	COVERS3    		-1072	  /*S3 axis velocity angle exceeded*/
#define	COVERE1    		-1073	  /*E1 axis velocity angle exceeded*/
#define	COVERE2    		-1074	  /*E2 axis velocity angle exceeded*/
#define	COVERW1    		-1075	  /*W1 axis velocity angle exceeded*/
#define	COVERW2     	-1076	  /*W2 axis velocity angle exceeded*/
							/*===============*/

/*	 EOperation continuity malfunction error: || iBrake-stop statusj*/

#define	ERR_OVER900		-2017	/*Arm length exceeded RMRC motion limitlength while in motion */

#define	ERR_S1_AGL		-2020	  /*S1 axis angle exceeded*/
#define	ERR_S2_AGL		-2021	  /*S2 axis angle exceeded*/
#define	ERR_S3_AGL		-2022	  /*S3 axis angle exceeded*/
#define	ERR_E1_AGL		-2023	  /*E1 axis angle exceeded*/
#define	ERR_E2_AGL		-2024	  /*E2 axis angle exceeded*/
#define	ERR_W1_AGL		-2025	  /*W1 axis angle exceeded*/
#define	ERR_W2_AGL		-2026	  /*W2 axis angle exceeded*/
							/*=== Ver.1.3 ====*/
#define	DOVERS1			-2030	  /*S1 axis direct control angle exceeded*/
#define	DOVERS2    		-2031	  /*S2 axis direct control angle exceeded*/
#define	DOVERS3    		-2032	  /*S3 axis direct control angle exceeded*/
#define	DOVERE1    		-2033	  /*E1 axis direct control angle exceeded*/
#define	DOVERE2    		-2034	  /*E2 axis direct control angle exceeded*/
#define	DOVERW1    		-2035	  /*W1 axis direct control angle exceeded*/
#define	DOVERW2     	-2036	  /*W2 axis direct control angle exceeded*/
							/*===============*/
#define	ERR_CANT_MOVE	-2051	/*RMRC control is not allowed at the current position.*/

#define	ERR_S1_REZ		-2060	  /*Anomalous S1 resolver deviation*/
#define	ERR_S2_REZ		-2061	  /*Anomalous S2 resolver deviation*/
#define	ERR_S3_REZ		-2062	  /*Anomalous S3 resolver deviation*/
#define	ERR_E1_REZ		-2063	  /*Anomalous E1 resolver deviation*/
#define	ERR_E2_REZ		-2064	  /*Anomalous E2 resolver deviation*/
#define	ERR_W1_REZ		-2065	  /*Anomalous W1 resolver deviation*/
#define	ERR_W2_REZ		-2066	  /*Anomalous W2 resolver deviation*/
/*
  <MEMO>Anomalous resolver deviation means when the resolver value inputted       
        at the previous time and the present time one exceed the allowable       
        range. (Incorrect loading, provokes missing data.)                        
*/ 
#define	ERR_TIMEOUT		-2070	  /*Automatically stopped on account of exceeding surveillance time. Ver.1.3*/
#define	ERR_SYNCOUT		-2071	  /*Not reaching the target value@Ver.1.3*/

#define	ERR_SYNC_S1		-2080	  /*Anomalous S1 axis synchronization in axis control*/
#define	ERR_SYNC_S2		-2081	  /*Anomalous S2 axis synchronization in axis control*/
#define	ERR_SYNC_S3		-2082	  /*Anomalous S3 axis synchronization in axis control*/
#define	ERR_SYNC_E1		-2083	  /*Anomalous E1 axis synchronization in axis control*/
#define	ERR_SYNC_E2		-2084	  /*Anomalous E2 axis synchronization in axis control*/
#define	ERR_SYNC_W1		-2085	  /*Anomalous W1 axis synchronization in axis control*/
#define	ERR_SYNC_W2		-2086	  /*Anomalous W2 axis synchronization in axis control*/
#define	ERR_RMRC_X		-2087	  /*Anomalous X axis synchronization in RMRC control*/
#define	ERR_RMRC_Y		-2088	  /*Anomalous Y axis synchronization in RMRC control*/
#define	ERR_RMRC_Z		-2089	  /*Anomalous Z axis synchronization in RMRC control*/
#define	ERR_VELOCITY	-2090	  /*Anomalous velocity deviation*/
#define	ERR_RMRC_YPR	-2091	  /*Anomalous tip orientation deviation in RMRC control*/

/*

 <MEMO>     Anomalous synchronization occurs when target and current value
            deviation exceed the allowable range. (Arm is not moving or rather
            delays motion.)

*/

/*	EFatal error || iControl stop status*/
	
#define	ERR_POWER_ON	-3000	/*control not started.*/
/*
 <MEMO> After fatal error occurred without issuing control start command, if
        other command is issued, this error occurs.
*/

#define ERR_EM_CTL		-3001	  /*Emergency stop is pushed.*/
#define	ERR_ARC_SEND	-3002	  /*Anomalous arc net communication Ver.1.3  */
				  				  
#define	ERR_FORCE_ON	-3010	  /*Not in force control  Ver.1.3  */
						/*====== Ver.1.3 ============*/
#define	ERR_D1_B15		-3020	 
#define	ERR_D1_B14		-3021	 
#define	ERR_D1_B13		-3022	  
#define	ERR_D1_B12		-3023	 
#define	ERR_D1_B11		-3024	  
#define	ERR_D1_B10		-3025	
#define	ERR_D1_B09		-3026	  
#define	ERR_D1_B08		-3027	 
#define	ERR_D1_B07		-3028
#define	ERR_D1_B06		-3029
#define	ERR_D1_B05		-3030
#define	ERR_D1_B04		-3031
#define	ERR_D1_B03		-3032
#define	ERR_D1_B02		-3033
#define	ERR_D1_B01		-3034
#define	ERR_D1_B00		-3035
                              
#define	ERR_D2_B15		-3040
#define	ERR_D2_B14		-3041
#define	ERR_D2_B13		-3042
#define	ERR_D2_B12		-3043
#define	ERR_D2_B11		-3044
#define	ERR_D2_B10		-3045
#define	ERR_D2_B09		-3046
#define	ERR_D2_B08		-3047
#define	ERR_D2_B07		-3048
#define	ERR_D2_B06		-3049
#define	ERR_D2_B05		-3050
#define	ERR_D2_B04		-3051
#define	ERR_D2_B03		-3052
#define	ERR_D2_B02		-3053
#define	ERR_D2_B01		-3054
#define	ERR_D2_B00		-3055
							/*==========================*/

#define	ERR_D1_COM		-3067
#define	ERR_D2_COM		-3068	 
#define	ERR_D3_COM		-3069	  

#define	ERR_D11_STA		-3071	  /*Anomalous servo driver (S1) status*/
#define	ERR_D12_STA		-3072	  /*Anomalous servo driver (S2) status*/
#define	ERR_D21_STA		-3073	  /*Anomalous servo driver (S3) status*/
#define	ERR_D22_STA		-3074	  /*Anomalous servo driver (E1) status*/
#define	ERR_D31_STA		-3075	  /*Anomalous servo driver (E2) status*/
#define	ERR_D32_STA		-3076	  /*Anomalous servo driver (W1) status*/
#define	ERR_D41_STA		-3077	  /*Anomalous servo driver (W2) status*/

#define	ERR_S_SUSPD		-3091	  /*Anomaly when issuing control (communication) start command*/
#define	ERR_E_SUSPD		-3092	  /*Anomaly when issuing control (communication) end command*/
#define	ERR_I_SUSPD		-3093	  /*Anomaly when issuing initialization command*/

/*
 <MEMO> Anomalous control command issuing means when issuing command to
        the servo driver, there is no response for a certain time. (Servo driver
        is anomalous.)
*/
							/*====== Ver.1.6 ============*/
#define	ERR_D3_B15		-3120	 
#define	ERR_D3_B14		-3121	 
#define	ERR_D3_B13		-3122	
#define	ERR_D3_B12		-3123	  
#define	ERR_D3_B11		-3124
#define	ERR_D3_B10		-3125	
#define	ERR_D3_B09		-3126	 
#define	ERR_D3_B08		-3127	 
#define	ERR_D3_B07		-3128	  
#define	ERR_D3_B06		-3129	 
#define	ERR_D3_B05		-3130	  
#define	ERR_D3_B04		-3131	 
#define	ERR_D3_B03		-3132	 
#define	ERR_D3_B02		-3133	  
#define	ERR_D3_B01		-3134	 
#define	ERR_D3_B00		-3135	  
                            
#define	ERR_D4_B15		-3140	 
#define	ERR_D4_B14		-3141	
#define	ERR_D4_B13		-3142	 
#define	ERR_D4_B12		-3143	  
#define	ERR_D4_B11		-3144	 
#define	ERR_D4_B10		-3145
#define	ERR_D4_B09		-3146	
#define	ERR_D4_B08		-3147	
#define	ERR_D4_B07		-3148	
#define	ERR_D4_B06		-3149	 
#define	ERR_D4_B05		-3150	
#define	ERR_D4_B04		-3151	
#define	ERR_D4_B03		-3152	  
#define	ERR_D4_B02		-3153
#define	ERR_D4_B01		-3154
#define	ERR_D4_B00		-3155	 

#define	ERR_D5_B15		-3220	
#define	ERR_D5_B14		-3221
#define	ERR_D5_B13		-3222	
#define	ERR_D5_B12		-3223	  
#define	ERR_D5_B11		-3224	
#define	ERR_D5_B10		-3225	 
#define	ERR_D5_B09		-3226	 
#define	ERR_D5_B08		-3227	
#define	ERR_D5_B07		-3228	 
#define	ERR_D5_B06		-3229	
#define	ERR_D5_B05		-3230
#define	ERR_D5_B04		-3231	  
#define	ERR_D5_B03		-3232	 
#define	ERR_D5_B02		-3233	  
#define	ERR_D5_B01		-3234	
#define	ERR_D5_B00		-3235	
                            
#define	ERR_D6_B15		-3240
#define	ERR_D6_B14		-3241
#define	ERR_D6_B13		-3242	 
#define	ERR_D6_B12		-3243	
#define	ERR_D6_B11		-3244	 
#define	ERR_D6_B10		-3245	
#define	ERR_D6_B09		-3246	  
#define	ERR_D6_B08		-3247	  
#define	ERR_D6_B07		-3248
#define	ERR_D6_B06		-3249	  
#define	ERR_D6_B05		-3250	 
#define	ERR_D6_B04		-3251	  
#define	ERR_D6_B03		-3252	
#define	ERR_D6_B02		-3253	 
#define	ERR_D6_B01		-3254	  
#define	ERR_D6_B00		-3255	  

#define	ERR_D7_B15		-3320	 
#define	ERR_D7_B14		-3321	  
#define	ERR_D7_B13		-3322	  
#define	ERR_D7_B12		-3323	 
#define	ERR_D7_B11		-3324	 
#define	ERR_D7_B10		-3325	  
#define	ERR_D7_B09		-3326	  
#define	ERR_D7_B08		-3327	  
#define	ERR_D7_B07		-3328	  
#define	ERR_D7_B06		-3329	  
#define	ERR_D7_B05		-3330	 
#define	ERR_D7_B04		-3331	 
#define	ERR_D7_B03		-3332	 
#define	ERR_D7_B02		-3333	
#define	ERR_D7_B01		-3334	
#define	ERR_D7_B00		-3335	 
                             
#define	ERR_D8_B15		-3340	
#define	ERR_D8_B14		-3341	  
#define	ERR_D8_B13		-3342	 
#define	ERR_D8_B12		-3343	 
#define	ERR_D8_B11		-3344	  
#define	ERR_D8_B10		-3345	 
#define	ERR_D8_B09		-3346	
#define	ERR_D8_B08		-3347	
#define	ERR_D8_B07		-3348
#define	ERR_D8_B06		-3349
#define	ERR_D8_B05		-3350	  
#define	ERR_D8_B04		-3351	  
#define	ERR_D8_B03		-3352	 
#define	ERR_D8_B02		-3353	 
#define	ERR_D8_B01		-3354	
#define	ERR_D8_B00		-3355	 



#define	ERR_BUS_TIMEOUT	 -4001	 
#define	ERR_BOAD_ACFAIL	 -4002	 
#define	ERR_WDT_TIMEOUT	 -4004	 
#define	ERR_VME_SYSFAIL	 -4008	  
#define	ERR_VME_ACFAIL	 -4016	  
#define	ERR_ABT_TIMEOUT	 -4032	  
#define	ERR_VME_TIMEOUT	 -4064	  

#endif
