Attribute VB_Name = "Module999"
'/*========================================================================
' *  datatype of PA10
' =========================================================================*/
Public ArmNo    As Long     ' current arm No

Public Const PAI As Single = 3.141592
'/*
' * Arm classification
' */
Public Const ARM0  As Long = 0
Public Const ARM1  As Long = 1
Public Const ARM2  As Long = 2
Public Const ARM3  As Long = 3
Public Const ARM4  As Long = 4
Public Const ARM5  As Long = 5
Public Const ARM6  As Long = 6
Public Const ARM7  As Long = 7
Public Const ARM8  As Long = 8
Public Const ARM9  As Long = 9
Public Const ARM10 As Long = 10
Public Const ARM11 As Long = 11
Public Const ARM12 As Long = 12
Public Const ARM13 As Long = 13
Public Const ARM14 As Long = 14
Public Const ARM15 As Long = 15

Public Const WM_WAIT As Long = 0
Public Const WM_NOWAIT  As Long = 1

'/*
' * Teach data structure
' */
Type PNTDATA
        S1      As Long
        S2      As Long
        S3      As Long
        E1      As Long
        E2      As Long
        W1      As Long
        W2      As Long
        speed   As Long
        rotate  As Long
        type    As Long
        fifo    As Long
        pattarn As Long
        time    As Long
        number  As Long
        tool0   As Long
        tool1   As Long
End Type

'/*
' * Axis data structure
' */
Type ANGLE
        S1  As Single
        S2  As Single
        S3  As Single
        E1  As Single
        E2  As Single
        W1  As Single
        W2  As Single
End Type

'/*
' *   Arm Status Structure
' */
Type ARMSTATUS
        remote      As Long
        count       As Long
        error       As Long
        agl         As ANGLE
        noap(3, 2)  As Single
        ypr(2)      As Single
End Type

'/*
' * Digital I/O structure
' */
Type DIOSTATUS
        io0     As Byte     '/*DIO 1ch*/
        io1     As Byte     '/*DIO 2ch*/
        io2     As Byte     '/*DIO 3ch*/
        io3     As Byte     '/*DIO 4ch*/
End Type

'/*
' * Parameter Structure:
' */
Type PARAM
        rezl    As Single        '/* Resolver resolution         */
        pul(6)  As Long          '/* Position limiter (+)     */
        pdl(6)  As Long          '/* Position limiter (-)     */
        vel(8)  As Long          '/* Velocity limiter          */
        dev(8)  As Long          '/* Default velocity         */
        pg1(6)  As Long          '/* Position control gain1       */
        pg2(6)  As Long          '/* Position control gain2    */
        vg1(6)  As Long          '/* Velocity control gain         */
        tg1(6)  As Long          '/* Force control gain          */
        pcm(6)  As Long          '/* position control selection matrix       */
        fcm(6)  As Long          '/* Force control selection matrix         */
        arl(6)  As Long          '/* Arm length             */
        arg(6)  As Long          '/* Axis gravity center position         */
        arw(6)  As Long          '/* Axis weight              */
        rfp(6)  As Long          '/* Home position recovery target value     */
        rsp(6)  As Long          '/* Escape position recovery target value      */
        rop(6)  As Long          '/* Recovery target value for other points    */
        tol(6)  As Long          '/* Tool parameter         */
        dmy(6)  As Long          '/* Not available*/
        spa(6)  As Long          '/* Spare                  */
End Type

'/*
' * Axis classificationFControl axis number selection
' */
Public Const S1 As Long = &H1
Public Const S2 As Long = &H2
Public Const S3 As Long = &H4
Public Const E1 As Long = &H8
Public Const E2 As Long = &H10
Public Const W1 As Long = &H20
Public Const W2 As Long = &H40

Public Const AXISALL        As Long = S1 + S2 + S3 + E1 + E2 + W1 + W2
Public Const LOCKAXIS_S1    As Long = S2 + S3 + E1 + E2 + W1 + W2
Public Const LOCKAXIS_S3    As Long = S1 + S2 + E1 + E2 + W1 + W2

'/*
' *   Servo driver classificationFControl servo driver number selection
' */
Public Const DRV1 As Long = 0
Public Const DRV2 As Long = 1
Public Const DRV3 As Long = 2
Public Const DRV4 As Long = 3

'/*
' *     Playback motion classification
'*/
Public Const PB_FORES As Long = 0
Public Const PB_BACKS As Long = 1
Public Const PB_FORE  As Long = 2
Public Const PB_BACK  As Long = 3

'/*
' *    Teach data deletion operation classification
' */
Public Const PD_CUR  As Long = &H7500   '/* Current point teach data deletion          */
Public Const PD_FORE As Long = &H7501   '/* Previous current point teach data deletion */
Public Const PD_ALL  As Long = &H7502   '/* All active teach data deletion             */

'/*
' *      Teach data attribution alteration classification
' */
Public Const PA_CHGVEL  As Long = &H7300
Public Const PA_CHGWAIT As Long = &H7301
Public Const PA_VELPTN  As Long = &H7302 '/* Velocity interpolation pattern alteration when in playback   */
Public Const PA_ROTVEL  As Long = &H7303 '/* Rotational velocity alteration when in playback              */
   
'/*
' *     Teach data type classification
' */
Public Const PT_CP      As Long = &H7100
Public Const PT_PTP     As Long = &H7101
Public Const PT_BCP     As Long = &H7102
Public Const PT_BPTP    As Long = &H7103
Public Const PT_ARC1    As Long = &H7104
Public Const PT_ARC2    As Long = &H7105
Public Const PT_ARC3    As Long = &H7106
Public Const PT_CIR1    As Long = &H7107
Public Const PT_CIR2    As Long = &H7108
Public Const PT_CIR3    As Long = &H7109
Public Const PT_AXS     As Long = &H710A
Public Const PT_BAXS    As Long = &H710B

'/*
' *     Teach data pointer operation classification
' */
Public Const PM_TOP     As Long = &H7100 '/* Moves pointer to top.                                                     */
Public Const PM_NEXT    As Long = &H7101 '/* Pointer forward, once.                                                    */
Public Const PM_PRIV    As Long = &H7102 '/* Pointer backward, once.                                                   */
Public Const PM_BTM     As Long = &H7103 '/* Moves pointer to bottom                                                   */
Public Const PM_JMP     As Long = &H7104 '/* Moves pointer to designated number.                                       */
Public Const PM_CIR     As Long = &H7105 '/* Circle teach point searched, moving pointer to teach point found first.   */
Public Const PM_ARC     As Long = &H7106 '/* Arc teach point searched, moving pointer to teach point found first.@@@*/

'/*
' *    Default velocity alteration classification
' */
Public Const VT_ONEVEL  As Long = &H0           '/* Each axis default velocity alteration        */
Public Const VT_XYZVEL  As Long = &H1           '/* Tip position default velocity alteration     */
Public Const VT_YPRVEL  As Long = &H2           '/* Tip orientation default velocity alteration  */

'/*
' *      Velocity control mode classification
' */
Public Const VM_XYZ1     As Long = &H200
Public Const VM_YPR1     As Long = &H201
Public Const VM_XYZ2     As Long = &H202
Public Const VM_YPR2     As Long = &H203
Public Const VM_ONE      As Long = &H204
Public Const VM_XYZYPR1  As Long = &H205
Public Const VM_XYZYPR2  As Long = &H206

'/*
' *      Redundant axis control mode classification
' */
Public Const JM_SET     As Long = &H345
Public Const JM_RESET   As Long = &H346
Public Const JM_VSET    As Long = &H347
Public Const JM_ON      As Long = &H348
Public Const JM_OFF     As Long = &H349
Public Const JM_S3ON    As Long = &H34A
Public Const JM_S3DIV   As Long = &H34B
Public Const JM_S3HOLD  As Long = &H34C

Public Const JT_RIGHT   As Long = 1
Public Const JT_HOLD    As Long = 0
Public Const JT_LEFT    As Long = -1

'/*
' *
' */
Public Const MM_XYZ     As Long = &H5680
Public Const MM_NOA     As Long = &H5681
Public Const MM_XYZNOA  As Long = &H5682

'/*
' *
' */
Public Const DM_STOP    As Long = 0
Public Const DM_START   As Long = 1

Public Const ARM_STANDING   As Long = 1         '/* Floor mounted           */
Public Const ARM_HANGING    As Long = -1        '/* suspending from ceiling */

'/*
' *   DIO port numbers
' */
Public Const DP_PORT0   As Long = 0
Public Const DP_PORT1   As Long = 1
Public Const DP_PORT2   As Long = 2
Public Const DP_PORT3   As Long = 3
Public Const DPO_PORT0  As Long = 4
Public Const DPO_PORT1  As Long = 5
Public Const DPO_PORT2  As Long = 6
Public Const DPO_PORT3  As Long = 7
Public Const DPX_PORT0  As Long = 8
Public Const DPX_PORT1  As Long = 9
Public Const DPX_PORT2  As Long = 10
Public Const DPX_PORT3  As Long = 11

'/*
' *   DIO channel numbers
' */
Public Const DC_CH1 As Long = 0
Public Const DC_CH2 As Long = 1
Public Const DC_CH3 As Long = 2
Public Const DC_CH4 As Long = 3
Public Const DC_CH5 As Long = 4
Public Const DC_CH6 As Long = 5
Public Const DC_CH7 As Long = 6
Public Const DC_CH8 As Long = 7
'/*
' *   Sensor correction coordinate classification
' */
Public Const MODE_XYZ1  As Long = &H1
Public Const MODE_XYZ2  As Long = &H2
Public Const MODE_XYZ3  As Long = &H4
Public Const MODE_XYZ4  As Long = &H8
Public Const MODE_WAVE1 As Long = &H10
Public Const MODE_WAVE2 As Long = &H20

'/*
' *  Teach point attribute designation
' */
Public Const PA_SETID As Long = &H7304

'/*
' *   Circle & arc teach point number designation
' */
Public Const PN_1 As Long = 1
Public Const PN_2 As Long = 2
Public Const PN_3 As Long = 3

'/*
' *   Sensor correction data structure
' */
Type TRANSMAT
        Enable   As Long                '/* As Long Designation bit                                              */
        xyz11(2) As Single              '/* As Single Mechanical interface coordinate absolute deviation correction value      */
                                                                     
        xyz12(2) As Single              '/* As Single Mechanical interface coordinate relative deviation correction value     */
                                                                      
        xyz21(2) As Single              '/* As Single Base coordinate absolute deviation correction value@      */
        xyz22(2) As Single              '/* As Single Base coordinate relative deviation correction value@      */
        wave1(2) As Single              '/* As Single Trajectory coordinate absolute deviation correction value  */
        wave2(2) As Single              '/* As Single Trajectory coordinate relative deviation correction value  */
End Type

'/*
' *      Other functions
' */
Type WAVATTR
        limit   As Long
        pitch   As Long
        depth   As Long
        width   As Long
        ANGLE   As Single
End Type

'/*
' *  Arm target value structure
' */
Type ARMTARGET
        agl         As ANGLE
        noap(3, 2)  As Single
        ypr(2)      As Single
End Type

#If VME Then
'/*===========================================================================
'        function@prototype declaration
'===========================================================================*/
Declare Function pa_ini_sys Lib "pavme.dll" () As Long
Declare Function pa_ter_sys Lib "pavme.dll" () As Long

Declare Function pa_opn_arm Lib "pavme.dll" (ByVal ARM As Long) As Long
Declare Function pa_cls_arm Lib "pavme.dll" (ByVal ARM As Long) As Long

Declare Function pa_sta_arm Lib "pavme.dll" (ByVal ARM As Long) As Long
Declare Function pa_ext_arm Lib "pavme.dll" (ByVal ARM As Long) As Long

Declare Function pa_stp_arm Lib "pavme.dll" (ByVal ARM As Long, ByVal wfp As Long) As Long
Declare Function pa_sus_arm Lib "pavme.dll" (ByVal ARM As Long, ByVal wfp As Long) As Long
Declare Function pa_rsm_arm Lib "pavme.dll" (ByVal ARM As Long, ByVal wfp As Long) As Long

Declare Function pa_exe_axs Lib "pavme.dll" (ByVal ARM As Long, ByVal axis As Long, ByRef agl As ANGLE, ByVal wfp As Long) As Long
Declare Function pa_exe_edr Lib "pavme.dll" (ByVal ARM As Long, ByVal axis As Long, ByRef agl As ANGLE, ByVal wfp As Long) As Long

Declare Function pa_exe_hom Lib "pavme.dll" (ByVal ARM As Long, ByVal wfp As Long) As Long
Declare Function pa_exe_esc Lib "pavme.dll" (ByVal ARM As Long, ByVal wfp As Long) As Long
Declare Function pa_exe_saf Lib "pavme.dll" (ByVal ARM As Long, ByVal wfp As Long) As Long

Declare Function pa_mov_XYZ Lib "pavme.dll" (ByVal ARM As Long, ByVal X As Single, ByVal Y As Single, ByVal z As Single, ByVal wfp As Long) As Long
Declare Function pa_mov_YPR Lib "pavme.dll" (ByVal ARM As Long, ByVal Y As Single, ByVal p As Single, ByVal r As Single, ByVal wfp As Long) As Long
Declare Function pa_mov_XYZ0 Lib "pavme.dll" (ByVal ARM As Long, ByVal X As Single, ByVal Y As Single, ByVal z As Single, ByVal wfp As Long) As Long
Declare Function pa_mov_YPR0 Lib "pavme.dll" (ByVal ARM As Long, ByVal Y As Single, ByVal p As Single, ByVal r As Single, ByVal wfp As Long) As Long

Declare Function pa_mov_mat Lib "pavme.dll" (ByVal ARM As Long, ByVal movemode As Long, ByRef matrix As Any, ByRef agl As ANGLE, ByVal wfp As Long) As Long

'/*
' *      Function on teach point operation & playback control
' */
Declare Function pa_chg_pnt Lib "pavme.dll" (ByVal ARM As Long, ByVal pntmove As Long, ByVal jpt As Long) As Long
Declare Function pa_add_pnt Lib "pavme.dll" (ByVal ARM As Long, ByVal pnttype As Long) As Long
Declare Function pa_del_pnt Lib "pavme.dll" (ByVal ARM As Long, ByVal pntdel As Long) As Long
Declare Function pa_rpl_pnt Lib "pavme.dll" (ByVal ARM As Long) As Long
Declare Function pa_set_pnt Lib "pavme.dll" (ByVal ARM As Long, ByVal pntattr As Long, ByVal da As Long) As Long

Declare Function pa_mov_pnt Lib "pavme.dll" (ByVal ARM As Long, ByVal wfp As Long) As Long
Declare Function pa_ply_pnt Lib "pavme.dll" (ByVal ARM As Long, ByVal mode As Long, ByVal wfp As Long) As Long
Declare Function pa_lod_pnt Lib "pavme.dll" (ByVal ARM As Long, ByVal file As String) As Long
Declare Function pa_sav_pnt Lib "pavme.dll" (ByVal ARM As Long, ByVal file As String) As Long

Declare Function pa_vel_pnt Lib "pavme.dll" (ByVal ARM As Long, ByVal vgain As Single) As Long

'/*
' *      Velocity control function
' */
Declare Function pa_mod_vel Lib "pavme.dll" (ByVal ARM As Long, ByVal velmode As Long, ByVal axis As Long) As Long
Declare Function pa_odr_vel Lib "pavme.dll" (ByVal ARM As Long, ByRef spd As Single) As Long

'/*
' *      Redundant axis control function
' */
Declare Function pa_mod_jou Lib "pavme.dll" (ByVal ARM As Long, ByVal joumode As Long) As Long
Declare Function pa_odr_jou Lib "pavme.dll" (ByVal ARM As Long, ByVal joutype As Long) As Long

'/*
' *      Tip absolute position/orientation
' */
Declare Function pa_mod_dpd Lib "pavme.dll" (ByVal ARM As Long) As Long
Declare Function pa_odr_dpd Lib "pavme.dll" (ByVal ARM As Long, ByRef matrix As Any, ByRef agl As ANGLE) As Long

'/*
' *      Direct control function
' */
Declare Function pa_wet_ded Lib "pavme.dll" (ByVal ARM As Long, ByVal axis As Long) As Long
Declare Function pa_get_amp Lib "pavme.dll" (ByVal ARM As Long) As Long
Declare Function pa_mod_dir Lib "pavme.dll" (ByVal ARM As Long, ByVal directmode As Long) As Long

'/*
' *     Function on position setting/definition
' */
Declare Function pa_set_hom Lib "pavme.dll" (ByVal ARM As Long, ByRef agl As ANGLE) As Long
Declare Function pa_set_esc Lib "pavme.dll" (ByVal ARM As Long, ByRef agl As ANGLE) As Long
Declare Function pa_set_saf Lib "pavme.dll" (ByVal ARM As Long, ByRef agl As ANGLE) As Long

Declare Function pa_def_hom Lib "pavme.dll" (ByVal ARM As Long) As Long
Declare Function pa_def_esc Lib "pavme.dll" (ByVal ARM As Long) As Long
Declare Function pa_def_saf Lib "pavme.dll" (ByVal ARM As Long) As Long

'/*
' *      Function on coordinate conversion matrix
' */
Declare Function pa_set_mtx Lib "pavme.dll" (ByVal ARM As Long, ByRef matrix As Any) As Long

'/*
' *      Arm status information loading function
' */
Declare Function pa_get_sts Lib "pavme.dll" (ByVal ARM As Long, ByRef st As ARMSTATUS) As Long
Declare Function pa_get_cnt Lib "pavme.dll" (ByVal ARM As Long, ByRef cnt As Long) As Long
Declare Function pa_get_err Lib "pavme.dll" (ByVal ARM As Long, ByRef err As Long) As Long
Declare Function pa_get_agl Lib "pavme.dll" (ByVal ARM As Long, ByRef agl As ANGLE) As Long
Declare Function pa_get_xyz Lib "pavme.dll" (ByVal ARM As Long, ByRef vec As Single) As Long
Declare Function pa_get_noa Lib "pavme.dll" (ByVal ARM As Long, ByRef matrix As Single) As Long
Declare Function pa_get_ypr Lib "pavme.dll" (ByVal ARM As Long, ByRef vecter As Single) As Long
Declare Function pa_get_prm Lib "pavme.dll" (ByVal ARM As Long, ByRef prm As PARAM) As Long
Declare Function pa_get_pnt Lib "pavme.dll" (ByVal ARM As Long, ByRef pd As PNTDATA) As Long
Declare Function pa_get_cur Lib "pavme.dll" (ByVal ARM As Long, ByRef cur As Long) As Long
Declare Function pa_get_num Lib "pavme.dll" (ByVal ARM As Long, ByRef num As Long) As Long

'/*
' *      Digital input/output function
' */
Declare Function pa_inp_dio Lib "pavme.dll" (ByVal ARM As Long, ByRef dio As DIOSTATUS) As Long
Declare Function pa_oup_dio Lib "pavme.dll" (ByVal ARM As Long, ByRef dio As DIOSTATUS) As Long
Declare Function pa_get_dio Lib "pavme.dll" (ByVal ARM As Long, ByVal port As Long, ByVal ch As Long, ByRef dat As Byte) As Long
Declare Function pa_set_dio Lib "pavme.dll" (ByVal ARM As Long, ByVal port As Long, ByVal ch As Long) As Long
Declare Function pa_rst_dio Lib "pavme.dll" (ByVal ARM As Long, ByVal port As Long, ByVal ch As Long) As Long

'/*
' *      Function on parameter
' */
Declare Function pa_set_tol Lib "pavme.dll" (ByVal ARM As Long, ByVal X As Long, ByVal Y As Long, ByVal z As Long, ByVal off As Long) As Long
Declare Function pa_set_vel Lib "pavme.dll" (ByVal ARM As Long, ByVal veltype As Long, ByRef vel As Single) As Long

Declare Function pa_lod_ctl Lib "pavme.dll" (ByVal ARM As Long, ByVal file As String) As Long
Declare Function pa_sav_ctl Lib "pavme.dll" (ByVal ARM As Long, ByVal file As String) As Long
Declare Function pa_lod_drv Lib "pavme.dll" (ByVal ARM As Long, ByVal driver As Long, ByVal file As String) As Long

Declare Function pa_lod_def Lib "pavme.dll" (ByVal ARM As Long) As Long
Declare Function pa_sav_def Lib "pavme.dll" (ByVal ARM As Long) As Long

Declare Function pa_map_ctl Lib "pavme.dll" (ByVal ARM As Long) As Long
Declare Function pa_fsh_chk Lib "pavme.dll" (ByVal ARM As Long) As Integer
Declare Function pa_req_ctl Lib "pavme.dll" (ByVal ARM As Long, ByVal ctl As Long) As Long
Declare Function pa_rst_ctl Lib "pavme.dll" (ByVal ARM As Long) As Long

Declare Function pa_err_mes Lib "pavme.dll" (ByVal ARM As Long, ByVal mess As String) As Long

Declare Function pa_clr_log Lib "pavme.dll" (ByVal ARM As Long) As Long
Declare Function pa_sav_log Lib "pavme.dll" (ByVal ARM As Long, ByVal file As String) As Long

'/*
' *      Arm status control function  /
' */
Declare Function pa_sta_sim Lib "pavme.dll" (ByVal ARM As Long) As Long
Declare Function pa_ext_sim Lib "pavme.dll" (ByVal ARM As Long) As Long

'/*
' *      Digital input/output function
' */
Declare Function pa_swt_dio Lib "pavme.dll" (ByVal ARM As Long, ByVal swt As Long) As Long
Declare Function pa_chg_dio Lib "pavme.dll" (ByVal ARM As Long, ByRef dio As DIOSTATUS) As Long
Declare Function pa_cpp_dio Lib "pavme.dll" (ByVal ARM As Long, ByRef dio1 As DIOSTATUS, ByRef dio2 As DIOSTATUS) As Long
                                                                                        
'/*
' *      Function on teach point operation & playback control
' */
Declare Function pa_set_idn Lib "pavme.dll" (ByVal ARM As Long, ByVal pntid As Long, ByVal dat As Long) As Long
Declare Function pa_get_idn Lib "pavme.dll" (ByVal ARM As Long, ByRef idn As Long) As Long
Declare Function pa_axs_pnt Lib "pavme.dll" (ByVal ARM As Long, ByVal wfp As Long) As Long
Declare Function pa_set_dlc Lib "pavme.dll" (ByVal ARM As Long, ByVal dlc As Long) As Long
Declare Function pa_get_dlc Lib "pavme.dll" (ByVal ARM As Long, ByRef dlc As Long) As Long

'/*
' *      Other functions
' */
Declare Function pa_set_wav Lib "pavme.dll" (ByVal ARM As Long, ByRef wav As WAVATTR) As Long
Declare Function pa_odr_xyz Lib "pavme.dll" (ByVal ARM As Long, ByRef XYZ As TRANSMAT) As Long
Declare Function pa_lmt_xyz Lib "pavme.dll" (ByVal ARM As Long, ByVal XYZ As Long) As Long
Declare Function pa_get_lmt Lib "pavme.dll" (ByVal ARM As Long, ByRef lmt As Single) As Long
Declare Function pa_fsh_sub Lib "pavme.dll" (ByVal ARM As Long) As Integer
Declare Function pa_req_sub Lib "pavme.dll" (ByVal ARM As Long, ByVal flg As Integer) As Long

'/*
' *      Function on coordinate conversion matrix
' */
Declare Function pa_set_mat Lib "pavme.dll" (ByVal ARM As Long, ByRef matrix1 As Single, ByRef matrix2 As Single) As Long

'/*
' *      Direct control function
' */
Declare Function pa_drt_ded Lib "pavme.dll" (ByVal ARM As Long, ByVal vec As Long) As Long
Declare Function pa_chk_cnt Lib "pavme.dll" (ByVal ARM As Long) As Long
Declare Function pa_set_tim Lib "pavme.dll" (ByVal ARM As Long, ByVal tim As Long) As Long

'/*
' *      Arm status information loading function
' */
Declare Function pa_get_mod Lib "pavme.dll" (ByVal ARM As Long, ByRef mode As Long) As Long
Declare Function pa_get_jou Lib "pavme.dll" (ByVal ARM As Long, ByRef jou As Long) As Long
Declare Function pa_get_ver Lib "pavme.dll" (ByVal ARM As Long, ByRef ver As Single) As Long
Declare Function pa_get_pvl Lib "pavme.dll" (ByVal ARM As Long, ByRef pvl As Single) As Long
Declare Function pa_get_pdo Lib "pavme.dll" (ByVal ARM As Long, ByRef pdo As Long) As Long
Declare Function pa_get_pcd Lib "pavme.dll" (ByVal ARM As Long, ByRef dio1 As DIOSTATUS, ByRef dio2 As DIOSTATUS) As Long
Declare Function pa_get_cpt Lib "pavme.dll" (ByVal ARM As Long, ByVal pntno As Long, ByRef dat As PNTDATA) As Long
Declare Function pa_get_mat Lib "pavme.dll" (ByVal ARM As Long, ByRef matrix1 As Single, ByRef matrix2 As Single) As Long
Declare Function pa_get_sns Lib "pavme.dll" (ByVal ARM As Long, ByRef sns As TRANSMAT) As Long
Declare Function pa_get_tar Lib "pavme.dll" (ByVal ARM As Long, ByRef tar As ARMTARGET) As Long
Declare Function pa_get_com Lib "pavme.dll" (ByVal ARM As Long, ByRef com As Long) As Long
Declare Function pa_get_tim Lib "pavme.dll" (ByVal ARM As Long, ByRef tim As Long) As Long
Declare Function pa_get_drt Lib "pavme.dll" (ByVal ARM As Long, ByRef drt As Long) As Long
Declare Function pa_get_cps Lib "pavme.dll" (ByVal ARM As Long, ByRef cps As Long) As Long

'/*
' *      Redundant axis control function
' */
Declare Function pa_mov_jou Lib "pavme.dll" (ByVal ARM As Long, ByVal jou As Single, ByVal wfp As Long) As Long
'/*
' *     Tip absolute position/orientation, axis real-time control function
' */
Declare Function pa_mod_axs Lib "pavme.dll" (ByVal ARM As Long) As Long
Declare Function pa_odr_axs Lib "pavme.dll" (ByVal ARM As Long, ByRef agl As ANGLE) As Long


'/* pa_egt.c */
Declare Function pa_get_lgh Lib "pavme.dll" (ByVal ARM As Long, ByRef lgh As Single) As Long
Declare Function pa_get_dsw Lib "pavme.dll" (ByVal ARM As Long, ByRef lgh As Long) As Long

'/*========force control function ========*/
Declare Function pa_chg_cod Lib "pavme.dll" (ByVal ARM As Long, ByVal coord As Long) As Long
Declare Function pa_rst_fce Lib "pavme.dll" (ByVal ARM As Long, ByVal rmd As Long) As Long
Declare Function pa_set_fmx Lib "pavme.dll" (ByVal ARM As Long, ByRef pmt As PFMAT) As Long
Declare Function pa_tgt_fce Lib "pavme.dll" (ByVal ARM As Long, ByRef fmt As FMTGT) As Long
Declare Function pa_sta_fce Lib "pavme.dll" (ByVal ARM As Long) As Long
Declare Function pa_ext_fce Lib "pavme.dll" (ByVal ARM As Long) As Long
Declare Function pa_chk_fce Lib "pavme.dll" (ByVal ARM As Long, ByVal fele As Long) As Integer
Declare Function pa_lod_fmp Lib "pavme.dll" (ByVal ARM As Long, ByVal file As String) As Long
Declare Function pa_set_len Lib "pavme.dll" (ByVal ARM As Long, ByVal dX As Single, ByVal dY As Single, ByVal dZ As Single) As Long
Declare Function pa_chg_sin Lib "pavme.dll" (ByVal ARM As Long, ByVal sign As Long) As Long

Declare Function pa_sav_rom Lib "pavme.dll" (ByVal ARM As Long) As Long
Declare Function pa_lod_rom Lib "pavme.dll" (ByVal ARM As Long) As Long
Declare Function pa_set_day Lib "pavme.dll" (ByVal ARM As Long, ByVal Y As Integer, ByVal m As Integer, ByVal d As Integer) As Long
Declare Function pa_set_tme Lib "pavme.dll" (ByVal ARM As Long, ByVal h As Integer, ByVal m As Integer, ByVal s As Integer) As Long

#Else   ' ISA

'/*===========================================================================
'        function@prototype declaration
'===========================================================================*/
Declare Function pa_ini_sys Lib "PAsim.dll" () As Long
Declare Function pa_ter_sys Lib "PAsim.dll" () As Long

Declare Function pa_opn_arm Lib "PAsim.dll" (ByVal ARM As Long) As Long
Declare Function pa_cls_arm Lib "PAsim.dll" (ByVal ARM As Long) As Long

Declare Function pa_sta_arm Lib "PAsim.dll" (ByVal ARM As Long) As Long
Declare Function pa_ext_arm Lib "PAsim.dll" (ByVal ARM As Long) As Long

Declare Function pa_stp_arm Lib "PAsim.dll" (ByVal ARM As Long, ByVal wfp As Long) As Long
Declare Function pa_sus_arm Lib "PAsim.dll" (ByVal ARM As Long, ByVal wfp As Long) As Long
Declare Function pa_rsm_arm Lib "PAsim.dll" (ByVal ARM As Long, ByVal wfp As Long) As Long

Declare Function pa_exe_axs Lib "PAsim.dll" (ByVal ARM As Long, ByVal axis As Long, ByRef agl As ANGLE, ByVal wfp As Long) As Long
Declare Function pa_exe_edr Lib "PAsim.dll" (ByVal ARM As Long, ByVal axis As Long, ByRef agl As ANGLE, ByVal wfp As Long) As Long

Declare Function pa_exe_hom Lib "PAsim.dll" (ByVal ARM As Long, ByVal wfp As Long) As Long
Declare Function pa_exe_esc Lib "PAsim.dll" (ByVal ARM As Long, ByVal wfp As Long) As Long
Declare Function pa_exe_saf Lib "PAsim.dll" (ByVal ARM As Long, ByVal wfp As Long) As Long

Declare Function pa_mov_XYZ Lib "PAsim.dll" (ByVal ARM As Long, ByVal X As Single, ByVal Y As Single, ByVal z As Single, ByVal wfp As Long) As Long
Declare Function pa_mov_YPR Lib "PAsim.dll" (ByVal ARM As Long, ByVal Y As Single, ByVal p As Single, ByVal r As Single, ByVal wfp As Long) As Long
Declare Function pa_mov_XYZ0 Lib "PAsim.dll" (ByVal ARM As Long, ByVal X As Single, ByVal Y As Single, ByVal z As Single, ByVal wfp As Long) As Long
Declare Function pa_mov_YPR0 Lib "PAsim.dll" (ByVal ARM As Long, ByVal Y As Single, ByVal p As Single, ByVal r As Single, ByVal wfp As Long) As Long

Declare Function pa_mov_mat Lib "PAsim.dll" (ByVal ARM As Long, ByVal movemode As Long, ByRef matrix As Any, ByRef agl As ANGLE, ByVal wfp As Long) As Long

'/*
' *      Function on teach point operation & playback control
' */
Declare Function pa_chg_pnt Lib "PAsim.dll" (ByVal ARM As Long, ByVal pntmove As Long, ByVal jpt As Long) As Long
Declare Function pa_add_pnt Lib "PAsim.dll" (ByVal ARM As Long, ByVal pnttype As Long) As Long
Declare Function pa_del_pnt Lib "PAsim.dll" (ByVal ARM As Long, ByVal pntdel As Long) As Long
Declare Function pa_rpl_pnt Lib "PAsim.dll" (ByVal ARM As Long) As Long
Declare Function pa_set_pnt Lib "PAsim.dll" (ByVal ARM As Long, ByVal pntattr As Long, ByVal da As Long) As Long

Declare Function pa_mov_pnt Lib "PAsim.dll" (ByVal ARM As Long, ByVal wfp As Long) As Long
Declare Function pa_ply_pnt Lib "PAsim.dll" (ByVal ARM As Long, ByVal mode As Long, ByVal wfp As Long) As Long
Declare Function pa_lod_pnt Lib "PAsim.dll" (ByVal ARM As Long, ByVal file As String) As Long
Declare Function pa_sav_pnt Lib "PAsim.dll" (ByVal ARM As Long, ByVal file As String) As Long

Declare Function pa_vel_pnt Lib "PAsim.dll" (ByVal ARM As Long, ByVal vgain As Single) As Long

'/*
' *      Velocity control function
' */
Declare Function pa_mod_vel Lib "PAsim.dll" (ByVal ARM As Long, ByVal velmode As Long, ByVal axis As Long) As Long
Declare Function pa_odr_vel Lib "PAsim.dll" (ByVal ARM As Long, ByRef spd As Single) As Long

'/*
' *      Redundant axis control function
' */
Declare Function pa_mod_jou Lib "PAsim.dll" (ByVal ARM As Long, ByVal joumode As Long) As Long
Declare Function pa_odr_jou Lib "PAsim.dll" (ByVal ARM As Long, ByVal joutype As Long) As Long

'/*
' *      Tip absolute position/orientation,
' */
Declare Function pa_mod_dpd Lib "PAsim.dll" (ByVal ARM As Long) As Long
Declare Function pa_odr_dpd Lib "PAsim.dll" (ByVal ARM As Long, ByRef matrix As Any, ByRef agl As ANGLE) As Long

'/*
' *      Direct control function
' */
Declare Function pa_wet_ded Lib "PAsim.dll" (ByVal ARM As Long, ByVal axis As Long) As Long
Declare Function pa_get_amp Lib "PAsim.dll" (ByVal ARM As Long) As Long
Declare Function pa_mod_dir Lib "PAsim.dll" (ByVal ARM As Long, ByVal directmode As Long) As Long

'/*
' *      Function on position setting
' */
Declare Function pa_set_hom Lib "PAsim.dll" (ByVal ARM As Long, ByRef agl As ANGLE) As Long
Declare Function pa_set_esc Lib "PAsim.dll" (ByVal ARM As Long, ByRef agl As ANGLE) As Long
Declare Function pa_set_saf Lib "PAsim.dll" (ByVal ARM As Long, ByRef agl As ANGLE) As Long

Declare Function pa_def_hom Lib "PAsim.dll" (ByVal ARM As Long) As Long
Declare Function pa_def_esc Lib "PAsim.dll" (ByVal ARM As Long) As Long
Declare Function pa_def_saf Lib "PAsim.dll" (ByVal ARM As Long) As Long

'/*
' *      Function on coordinate conversion matrix
' */
Declare Function pa_set_mtx Lib "PAsim.dll" (ByVal ARM As Long, ByRef matrix As Any) As Long

'/*
' *      Arm status information loading function
' */
Declare Function pa_get_sts Lib "PAsim.dll" (ByVal ARM As Long, ByRef st As ARMSTATUS) As Long
Declare Function pa_get_cnt Lib "PAsim.dll" (ByVal ARM As Long, ByRef cnt As Long) As Long
Declare Function pa_get_err Lib "PAsim.dll" (ByVal ARM As Long, ByRef err As Long) As Long
Declare Function pa_get_agl Lib "PAsim.dll" (ByVal ARM As Long, ByRef agl As ANGLE) As Long
Declare Function pa_get_xyz Lib "PAsim.dll" (ByVal ARM As Long, ByRef vec As Single) As Long
Declare Function pa_get_noa Lib "PAsim.dll" (ByVal ARM As Long, ByRef matrix As Single) As Long
Declare Function pa_get_ypr Lib "PAsim.dll" (ByVal ARM As Long, ByRef vecter As Single) As Long
Declare Function pa_get_prm Lib "PAsim.dll" (ByVal ARM As Long, ByRef prm As PARAM) As Long
Declare Function pa_get_pnt Lib "PAsim.dll" (ByVal ARM As Long, ByRef pd As PNTDATA) As Long
Declare Function pa_get_cur Lib "PAsim.dll" (ByVal ARM As Long, ByRef cur As Long) As Long
Declare Function pa_get_num Lib "PAsim.dll" (ByVal ARM As Long, ByRef num As Long) As Long

'/*
' *      Digital input/output function
' */
Declare Function pa_inp_dio Lib "PAsim.dll" (ByVal ARM As Long, ByRef dio As DIOSTATUS) As Long
Declare Function pa_oup_dio Lib "PAsim.dll" (ByVal ARM As Long, ByRef dio As DIOSTATUS) As Long
Declare Function pa_get_dio Lib "PAsim.dll" (ByVal ARM As Long, ByVal port As Long, ByVal ch As Long, ByRef dat As Byte) As Long
Declare Function pa_set_dio Lib "PAsim.dll" (ByVal ARM As Long, ByVal port As Long, ByVal ch As Long) As Long
Declare Function pa_rst_dio Lib "PAsim.dll" (ByVal ARM As Long, ByVal port As Long, ByVal ch As Long) As Long

'/*
' *      Function on parameter
' */
Declare Function pa_set_tol Lib "PAsim.dll" (ByVal ARM As Long, ByVal X As Long, ByVal Y As Long, ByVal z As Long, ByVal off As Long) As Long
Declare Function pa_set_vel Lib "PAsim.dll" (ByVal ARM As Long, ByVal veltype As Long, ByRef vel As Single) As Long

Declare Function pa_lod_ctl Lib "PAsim.dll" (ByVal ARM As Long, ByVal file As String) As Long
Declare Function pa_sav_ctl Lib "PAsim.dll" (ByVal ARM As Long, ByVal file As String) As Long
Declare Function pa_lod_drv Lib "PAsim.dll" (ByVal ARM As Long, ByVal driver As Long, ByVal file As String) As Long

Declare Function pa_lod_def Lib "PAsim.dll" (ByVal ARM As Long) As Long
Declare Function pa_sav_def Lib "PAsim.dll" (ByVal ARM As Long) As Long

Declare Function pa_map_ctl Lib "PAsim.dll" (ByVal ARM As Long) As Long
Declare Function pa_fsh_chk Lib "PAsim.dll" (ByVal ARM As Long) As Integer
Declare Function pa_req_ctl Lib "PAsim.dll" (ByVal ARM As Long, ByVal ctl As Long) As Long
Declare Function pa_rst_ctl Lib "PAsim.dll" (ByVal ARM As Long) As Long

Declare Function pa_err_mes Lib "PAsim.dll" (ByVal ARM As Long, ByVal mess As String) As Long

Declare Function pa_clr_log Lib "PAsim.dll" (ByVal ARM As Long) As Long
Declare Function pa_sav_log Lib "PAsim.dll" (ByVal ARM As Long, ByVal file As String) As Long

'/*
' *      Initialization Function
' */
Declare Function pa_sta_sim Lib "PAsim.dll" (ByVal ARM As Long) As Long
Declare Function pa_ext_sim Lib "PAsim.dll" (ByVal ARM As Long) As Long

'/*
' *      Digital input/output function
' */
Declare Function pa_swt_dio Lib "PAsim.dll" (ByVal ARM As Long, ByVal swt As Long) As Long
Declare Function pa_chg_dio Lib "PAsim.dll" (ByVal ARM As Long, ByRef dio As DIOSTATUS) As Long
Declare Function pa_cpp_dio Lib "PAsim.dll" (ByVal ARM As Long, ByRef dio1 As DIOSTATUS, ByRef dio2 As DIOSTATUS) As Long
                                                                                        
'/*
' *      Function on teach point operation & playback control
' */
Declare Function pa_set_idn Lib "PAsim.dll" (ByVal ARM As Long, ByVal pntid As Long, ByVal dat As Long) As Long
Declare Function pa_get_idn Lib "PAsim.dll" (ByVal ARM As Long, ByRef idn As Long) As Long
Declare Function pa_axs_pnt Lib "PAsim.dll" (ByVal ARM As Long, ByVal wfp As Long) As Long
Declare Function pa_set_dlc Lib "PAsim.dll" (ByVal ARM As Long, ByVal dlc As Long) As Long
Declare Function pa_get_dlc Lib "PAsim.dll" (ByVal ARM As Long, ByRef dlc As Long) As Long

'/*
' *      Other functions
' */
Declare Function pa_set_wav Lib "PAsim.dll" (ByVal ARM As Long, ByRef wav As WAVATTR) As Long
Declare Function pa_odr_xyz Lib "PAsim.dll" (ByVal ARM As Long, ByRef XYZ As TRANSMAT) As Long
Declare Function pa_lmt_xyz Lib "PAsim.dll" (ByVal ARM As Long, ByVal XYZ As Long) As Long
Declare Function pa_get_lmt Lib "PAsim.dll" (ByVal ARM As Long, ByRef lmt As Single) As Long
Declare Function pa_fsh_sub Lib "PAsim.dll" (ByVal ARM As Long) As Integer
Declare Function pa_req_sub Lib "PAsim.dll" (ByVal ARM As Long, ByVal flg As Integer) As Long

'/*
' *      Function on coordinate conversion matrix
' */
Declare Function pa_set_mat Lib "PAsim.dll" (ByVal ARM As Long, ByRef matrix1 As Single, ByRef matrix2 As Single) As Long

'/*
' *      Direct control function
' */
Declare Function pa_drt_ded Lib "PAsim.dll" (ByVal ARM As Long, ByVal vec As Long) As Long
Declare Function pa_chk_cnt Lib "PAsim.dll" (ByVal ARM As Long) As Long
Declare Function pa_set_tim Lib "PAsim.dll" (ByVal ARM As Long, ByVal tim As Long) As Long

'/*
' *      Arm status information loading function
' */
Declare Function pa_get_mod Lib "PAsim.dll" (ByVal ARM As Long, ByRef mode As Long) As Long
Declare Function pa_get_jou Lib "PAsim.dll" (ByVal ARM As Long, ByRef jou As Long) As Long
Declare Function pa_get_ver Lib "PAsim.dll" (ByVal ARM As Long, ByRef ver As Single) As Long
Declare Function pa_get_pvl Lib "PAsim.dll" (ByVal ARM As Long, ByRef pvl As Single) As Long
Declare Function pa_get_pdo Lib "PAsim.dll" (ByVal ARM As Long, ByRef pdo As Long) As Long
Declare Function pa_get_pcd Lib "PAsim.dll" (ByVal ARM As Long, ByRef dio1 As DIOSTATUS, ByRef dio2 As DIOSTATUS) As Long
Declare Function pa_get_cpt Lib "PAsim.dll" (ByVal ARM As Long, ByVal pntno As Long, ByRef dat As PNTDATA) As Long
Declare Function pa_get_mat Lib "PAsim.dll" (ByVal ARM As Long, ByRef matrix1 As Single, ByRef matrix2 As Single) As Long
Declare Function pa_get_sns Lib "PAsim.dll" (ByVal ARM As Long, ByRef sns As TRANSMAT) As Long
Declare Function pa_get_tar Lib "PAsim.dll" (ByVal ARM As Long, ByRef tar As ARMTARGET) As Long
Declare Function pa_get_com Lib "PAsim.dll" (ByVal ARM As Long, ByRef com As Long) As Long
Declare Function pa_get_tim Lib "PAsim.dll" (ByVal ARM As Long, ByRef tim As Long) As Long
Declare Function pa_get_drt Lib "PAsim.dll" (ByVal ARM As Long, ByRef drt As Long) As Long
Declare Function pa_get_cps Lib "PAsim.dll" (ByVal ARM As Long, ByRef cps As Long) As Long

'/*
' *      Redundant axis control function
' */
Declare Function pa_mov_jou Lib "PAsim.dll" (ByVal ARM As Long, ByVal jou As Single, ByVal wfp As Long) As Long
'/*
' *      axis real-time control function
' */
Declare Function pa_mod_axs Lib "PAsim.dll" (ByVal ARM As Long) As Long
Declare Function pa_odr_axs Lib "PAsim.dll" (ByVal ARM As Long, ByRef agl As ANGLE) As Long


'/* pa_egt.c */
Declare Function pa_get_lgh Lib "PAsim.dll" (ByVal ARM As Long, ByRef lgh As Single) As Long
Declare Function pa_get_dsw Lib "PAsim.dll" (ByVal ARM As Long, ByRef lgh As Long) As Long


Declare Function pa_sav_rom Lib "PAsim.dll" (ByVal ARM As Long) As Long
Declare Function pa_lod_rom Lib "PAsim.dll" (ByVal ARM As Long) As Long
Declare Function pa_set_day Lib "PAsim.dll" (ByVal ARM As Long, ByVal Y As Integer, ByVal m As Integer, ByVal d As Integer) As Long
Declare Function pa_set_tme Lib "PAsim.dll" (ByVal ARM As Long, ByVal h As Integer, ByVal m As Integer, ByVal s As Integer) As Long

Declare Function pa_sta_log Lib "PAsim.dll" (ByVal ARM As Long, ByVal cyc As Long, ByVal sec As Long) As Long     'O擾p֐A(06/04/28ǉ)
Declare Function pa_end_log Lib "PAsim.dll" (ByVal ARM As Long) As Long

#End If

Public Const NoStatus   As Long = 1  ' /** ------ **/
Public Const Initial    As Long = 2  '/** ------ **/
Public Const BrakeStop  As Long = 3  '/** Brake-stop**/
Public Const SelfCheck  As Long = 4  '/** ------ **/
Public Const InputCheck As Long = 5  '/** ------ **/
Public Const OutputCheck As Long = 6 '/** ------ **/
Public Const ParamSet   As Long = 7  '/** ------ **/
Public Const EachAngle  As Long = 8  '/** Axis velocity control **/
Public Const EachVelocity As Long = 9 '/** Axis velocity control**/
Public Const Direct     As Long = 10 '/**Servo-lock **/
Public Const Current    As Long = 11
Public Const DeadWeight As Long = 12 '/** Weight compensation **/
Public Const RMRC       As Long = 13 '/** RMRC control (RMRC velocity control)**/
Public Const RMRCMatching As Long = 14 '/** RMRC redundant axis correction**/
Public Const PouseA     As Long = 15 '/** Axis control servo-lock **/
Public Const Program    As Long = 16
Public Const ProgramMatching As Long = 17 '/** Playback axis correction **/
Public Const MakeCircle As Long = 18 '/** Playback circle interpolation **/
Public Const MakeLine   As Long = 19 '/** Playback linear interpolation **/
Public Const MakeArc    As Long = 20 '/** Playback arc interpolation **/
Public Const PouseB     As Long = 21 '/** RMRC control servo-lock **/
Public Const Ready      As Long = 22 '/** Playback start waiting **/
'/**                     (23)    Reserved        */
'/**                     (24)    Reserved        */
Public Const Ready2     As Long = 25 '/** Playback start waiting **/
Public Const ToReady    As Long = 26 '/** Playback tip correction**/
Public Const RMRCsub    As Long = 27 '/** Redundant axis control **/

Public Const RMRCreal   As Long = 28 '/** RMRC real-time controlh **/
Public Const MakeAxis   As Long = 29 '/** Playback axis interpolation **/
Public Const RMRCmtx    As Long = 30 '/** Coordinate conversion position correction **/
Public Const RMRCsub2   As Long = 31 '/** Redundant S3 axis interpolation control **/
Public Const AXISreal   As Long = 32 '/** Axis real-time control **/

