Option Strict Off
Option Explicit On
Friend Class Form1
	Inherits System.Windows.Forms.Form
	Dim ret As Integer
	Private Const r2d As Single = 180 / PAI
	Private Const d2r As Single = PAI / 180
	
	
	
	Private Sub Command1_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command1.Click
		Dim ERR_OK As Object
		
		'=== System setting ===
        ret = pa_ini_sys()
        ret = pa_opn_arm(ARM0) ' select control ( ARM0~ARM15 )
		ret = pa_sta_sim(ARM0) ' select simulation
		
		'ret = pa_sta_log(ARM0, 40, 120) 'start logger
		'========================================================================
		'FUNCTION :
		'   To start logger for arm infomation
        'SYNTAX :
		'   long pa_sta_log(ARM armno,long cyc,long sec)
        '       armno   armNo( ARM0~ARM15 )
        '       cyc     log interval[msec]
        '       sec     log time [sec]
		'
		'========================================================================
		
		
		
		'=== pa_exe_axs : Each axis angle control ===
		Dim agl As ANGLE
		agl.S1 = 180 * d2r
		agl.S2 = 15 * d2r
		agl.E1 = 30 * d2r
		agl.W1 = 45 * d2r
		ret = pa_exe_axs(ARM0, S2 Or E1 Or W1, agl, WM_WAIT)
		'
		
		MsgBox("pa_exe_axs : OK!")
		
		
		
		'=== pa_get_agl : Load arm current each axis values ===
		ret = pa_get_agl(ARM0, agl)
		Text1(0).Text = VB6.Format(agl.S1 * r2d, "###0.0")
		Text1(1).Text = VB6.Format(agl.S2 * r2d, "###0.0")
		Text1(2).Text = VB6.Format(agl.S3 * r2d, "###0.0")
		Text1(3).Text = VB6.Format(agl.E1 * r2d, "###0.0")
		Text1(4).Text = VB6.Format(agl.E2 * r2d, "###0.0")
		Text1(5).Text = VB6.Format(agl.W1 * r2d, "###0.0")
		Text1(6).Text = VB6.Format(agl.W2 * r2d, "###0.0")
		
		MsgBox("pa_get_agl : OK!")
		
		
		
		'=== pa_get_xyz : Load arm current tip pasition ===
		Dim vec(3) As Single
		ret = pa_get_xyz(ARM0, vec(0))
		Text2(0).Text = VB6.Format(vec(0), "####0.0")
		Text2(1).Text = VB6.Format(vec(1), "####0.0")
		Text2(2).Text = VB6.Format(vec(2), "####0.0")
		
		MsgBox("pa_get_xyz : OK!")
		
		
		
		'=== pa_mov_XYZ : Position deviation control in robot coordinates ===
		Dim X As Single
		Dim Y As Single
		Dim Z As Single
		X = 0
		Y = 150 - vec(1)
		Z = 700 - vec(2)
		
		ret = pa_mov_XYZ(ARM0, X, Y, Z, WM_WAIT)
		
		ret = pa_get_xyz(ARM0, vec(0))
		Text2(0).Text = VB6.Format(vec(0), "####0.0")
		Text2(1).Text = VB6.Format(vec(1), "####0.0")
		Text2(2).Text = VB6.Format(vec(2), "####0.0")
		
		MsgBox("pa_mov_XYZ : OK!")
		
		
		
		'=== pa_mov_XYZ0 : Position deviation control in arm tip coordinates ===
		X = 0
		Y = 0
		Z = 701.5 - vec(0)
		ret = pa_mov_XYZ0(ARM0, X, Y, Z, WM_WAIT)
		
		ret = pa_get_xyz(ARM0, vec(0))
		Text2(0).Text = VB6.Format(vec(0), "####0.0")
		Text2(1).Text = VB6.Format(vec(1), "####0.0")
		Text2(2).Text = VB6.Format(vec(2), "####0.0")
		
		MsgBox("pa_mov_XYZ0 : OK!")
		
		
		
		
		'=== pa_get_noa : Load arm current orientation matrix ===
		Dim noap(3, 2) As Single
		ret = pa_get_noa(ARM0, noap(0, 0))
		Text3(0).Text = VB6.Format(noap(0, 0), "#0.0")
		Text3(1).Text = VB6.Format(noap(0, 1), "#0.0")
		Text3(2).Text = VB6.Format(noap(0, 2), "#0.0")
		
		Text3(3).Text = VB6.Format(noap(1, 0), "#0.0")
		Text3(4).Text = VB6.Format(noap(1, 1), "#0.0")
		Text3(5).Text = VB6.Format(noap(1, 2), "#0.0")
		
		Text3(6).Text = VB6.Format(noap(2, 0), "#0.0")
		Text3(7).Text = VB6.Format(noap(2, 1), "#0.0")
		Text3(8).Text = VB6.Format(noap(2, 2), "#0.0")
		
		Text3(9).Text = VB6.Format(noap(3, 0), "###0.0")
		Text3(10).Text = VB6.Format(noap(3, 1), "###0.0")
		Text3(11).Text = VB6.Format(noap(3, 2), "###0.0")
		
		MsgBox("pa_get_noa : OK!")
		
		
		
		'error check(1)
		'=== pa_mov_mat : Arm tip position/orientation absolute position control ===
		'Dim err As Long
		Dim mat(3, 2) As Single
		Dim an As ANGLE
		mat(0, 0) = 0# ' nx
		mat(0, 1) = 0# ' ny
		mat(0, 2) = -1# ' nz
		mat(1, 0) = 0# ' ox
		mat(1, 1) = 1# ' oy
		mat(1, 2) = 0# ' oz
		mat(2, 0) = 1# ' ax
		mat(2, 1) = 0# ' ay
		mat(2, 2) = 0# ' az
		mat(3, 0) = 701.5 ' px
		mat(3, 1) = -150# ' py
		mat(3, 2) = 400# ' pz
		an.S1 = 0 * d2r
		an.S2 = 0 * d2r
		an.S3 = 0 * d2r
		an.E1 = 90 * d2r
		an.E2 = 0 * d2r
		an.W1 = 0 * d2r
		an.W2 = 0 * d2r
		
		ret = pa_mov_mat(ARM0, MM_XYZ, mat(0, 0), an, WM_WAIT)
		'UPGRADE_WARNING: Couldn't resolve default property of object ERR_OK. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		If ret <> ERR_OK Then
			MsgBox("pa_mov_mat : Err! (" & ret & ")")
			ret = 0
		Else
			MsgBox("pa_mov_mat : OK!")
		End If
		
		
		
		'=== pa_mov_XYZ : Position deviation control in robot coordinates===
		X = -100
		Y = 0
		Z = 0
		ret = pa_mov_XYZ(ARM0, X, Y, Z, WM_WAIT)
		
		MsgBox("pa_mov_XYZ : OK!")
		
		
		
		'error check(2)
		'=== pa_exe_axs : Each axis angle control ===
		Dim cnt0 As Integer
		Dim cnt1 As Integer
		
		agl.S1 = -60 * d2r
		agl.S3 = 0 * d2r
		agl.E2 = 0 * d2r
		agl.W2 = 0 * d2r
		
		ret = pa_get_cnt(ARM0, cnt0)
		ret = pa_exe_axs(ARM0, S1 Or S3 Or E2 Or W2, agl, WM_NOWAIT)
		'Timer1.Enabled = True
		Do While 1
			ret = pa_get_cnt(ARM0, cnt1)
			'UPGRADE_WARNING: Couldn't resolve default property of object ERR_OK. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			If ret <> ERR_OK Then
				MsgBox("pa_exe_axs : Error!")
				'Timer1.Enabled = False
				Exit Do
			Else
				If cnt1 <> cnt0 Then
					MsgBox("pa_exe_axs : OK!")
					'Timer1.Enabled = False
					Exit Do
				Else
					
					'=== pa_get_xyz : Load arm current tip position ===
					ret = pa_get_xyz(ARM0, vec(0))
					Text2(0).Text = VB6.Format(vec(0), "####0.0")
					Text2(1).Text = VB6.Format(vec(1), "####0.0")
					Text2(2).Text = VB6.Format(vec(2), "####0.0")
					'=== pa_get_agl : Load arm current each axis values ===
					ret = pa_get_agl(ARM0, agl)
					Text1(0).Text = VB6.Format(agl.S1 * r2d, "###0.0")
					Text1(1).Text = VB6.Format(agl.S2 * r2d, "###0.0")
					Text1(2).Text = VB6.Format(agl.S3 * r2d, "###0.0")
					Text1(3).Text = VB6.Format(agl.E1 * r2d, "###0.0")
					Text1(4).Text = VB6.Format(agl.E2 * r2d, "###0.0")
					Text1(5).Text = VB6.Format(agl.W1 * r2d, "###0.0")
					Text1(6).Text = VB6.Format(agl.W2 * r2d, "###0.0")
					
					MsgBox("task being run")
				End If
			End If
		Loop 
		
		
		'=== Each axis motin control function ===
		ret = pa_exe_hom(ARM0, WM_WAIT) ' Each axis contorol to basic posture
		MsgBox("pa_exe_hom : OK!")
		
		ret = pa_exe_saf(ARM0, WM_WAIT) ' Each axis cotrol to escape posture
		MsgBox("pa_exe_saf : OK!")
		
		ret = pa_exe_esc(ARM0, WM_WAIT) ' Each aaxis control to safe posture
		MsgBox("pa_exe_esc : OK!")
		
		ret = pa_exe_hom(ARM0, WM_WAIT)
		MsgBox("pa_exe_hom : OK!")
		
		'ret = pa_end_log(ARM0)
		'========================================================================
		'FUNCTION :
		'   To end logger for arm infomation and make a "kinema0.log"
		'SYNTAX :
		'   llong pa_end_log(ARM armno)
        '         armno   armNo.( ARM0~ARM15 )
		'========================================================================
		
		
		
		'=== Arm condition control function ===
		ret = pa_ext_arm(ARM0) ' Simulation control end("pa_ext_arm" serves to substitute for "pa_ext_sim")
		ret = pa_cls_arm(ARM0) ' Close arm(disengage control arm)
		ret = pa_ter_sys() ' Termination of PA-Library
	End Sub
	
	
	
	Private Sub Command2_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command2.Click
		End
	End Sub
	
	
	
	Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick
		'=== pa_get_xyz : Load arm current tip position ===
		Dim vec(3) As Single
		ret = pa_get_xyz(ARM0, vec(0))
		Text2(0).Text = VB6.Format(vec(0), "####0.0")
		Text2(1).Text = VB6.Format(vec(1), "####0.0")
		Text2(2).Text = VB6.Format(vec(2), "####0.0")
		'=== pa_get_agl : Load arm current each axis values ===
		Dim agl As ANGLE
		ret = pa_get_agl(ARM0, agl)
		Text1(0).Text = VB6.Format(agl.S1 * r2d, "###0.0")
		Text1(1).Text = VB6.Format(agl.S2 * r2d, "###0.0")
		Text1(2).Text = VB6.Format(agl.S3 * r2d, "###0.0")
		Text1(3).Text = VB6.Format(agl.E1 * r2d, "###0.0")
		Text1(4).Text = VB6.Format(agl.E2 * r2d, "###0.0")
		Text1(5).Text = VB6.Format(agl.W1 * r2d, "###0.0")
		Text1(6).Text = VB6.Format(agl.W2 * r2d, "###0.0")
		
		MsgBox("timer1 done!")
	End Sub

    Private Sub _Label3_0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _Label3_0.Click

    End Sub

    Private Sub _Label4_0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _Label4_0.Click

    End Sub
End Class