Attribute VB_Name = "PAerr"

'/*Normal*/
Public Const ERR_OK          As Long = 0                '/* No error */

'/*Operation control section (PA library) detection error:*/
Public Const ERR_FILE        As Long = -1               '/* Designated file not existing*/
Public Const ERR_READ        As Long = -2               '/* File loading failure*/
Public Const ERR_WRITE       As Long = -3               '/* File saving failure*/
Public Const ERR_INT         As Long = -4               '/* Unsuccessful interruption into 486*/
Public Const ERR_OPEN        As Long = -5               '/* pa_opn_arm() not executed*/

'/*EParameter error:*/
Public Const ERR_ARM         As Long = -20              '/* Designated arm not existing*/
Public Const ERR_AXIS        As Long = -21              '/* Designated axis not existing*/
Public Const ERR_DRV         As Long = -22              '/* Designated driver not existing*/
Public Const ERR_PB          As Long = -23              '/* Incorrect playback motion mode*/
Public Const ERR_PD          As Long = -24              '/* Incorrect teach point deletion mode*/
Public Const ERR_PA          As Long = -25              '/* Incorrect teach point attribution mode*/
Public Const ERR_PTN         As Long = -26              '/* Incorrect teach point velocity pattern attribution value*/
Public Const ERR_PT          As Long = -27              '/* Incorrect teach point data type*/
Public Const ERR_PM          As Long = -28              '/* Incorrect teach point operation type*/
Public Const ERR_VT          As Long = -29              '/* Incorrect default velocity alteration type*/
Public Const ERR_VM          As Long = -30              '/* Incorrect velocity control mode*/
Public Const ERR_JM          As Long = -31              '/* Incorrect redundant axis control mode*/
Public Const ERR_JT          As Long = -32              '/* Incorrect redundant axis operation mode*/
Public Const ERR_MM          As Long = -33              '/* Incorrect target tip matrix control mode*/
Public Const ERR_DM          As Long = -34              '/* Incorrect direct control mode*/
Public Const ERR_DP          As Long = -35              '/* Incorrect digital input/output port designation*/
Public Const ERR_DC          As Long = -36              '/* Incorrect digital input/output channel designation*/
Public Const ERR_MES         As Long = -37              '/* Error code not defined*/

'/*EWarning error:*/
Public Const ERR_CANT_CPU    As Long = -1000            '/*Access to motion controller not allowed.*/
Public Const ERR_NON_EVNT    As Long = -1001            '/*Format does not match with command.*/
Public Const ERR_CANT_EVNT   As Long = -1002            '/*Command not compatible with current mode*/
Public Const ERR_INVALD_EVNT As Long = -1003            '/*Invalid command*/

Public Const ERR_S1_VEL      As Long = -1010            '/*S1 axis velocity exceeded*/
Public Const ERR_S2_VEL      As Long = -1011            '/*S2 axis velocity exceeded*/
Public Const ERR_S3_VEL      As Long = -1012            '/*S3 axis velocity exceeded*/
Public Const ERR_E1_VEL      As Long = -1013            '/*E1 axis velocity exceeded*/
Public Const ERR_E2_VEL      As Long = -1014            '/*E2 axis velocity exceeded*/
Public Const ERR_W1_VEL      As Long = -1015            '/*W1 axis velocity exceeded*/
Public Const ERR_W2_VEL      As Long = -1016            '/*W2 axis velocity exceeded*/

Public Const ERR_XYZ_VEL     As Long = -1018            '/*Tip linear velocity exceeded */
Public Const ERR_YPR_VEL     As Long = -1019            '/Tip rotational velocity exceeded */

Public Const ERR_S1_SAGL     As Long = -1020            '/*S1 axis safety angle exceeded*/
Public Const ERR_S2_SAGL     As Long = -1021            '/*S2 axis safety angle exceeded*/
Public Const ERR_S3_SAGL     As Long = -1022            '/*S3 axis safety angle exceeded*/
Public Const ERR_E1_SAGL     As Long = -1023            '/*E1 axis safety angle exceeded*/
Public Const ERR_E2_SAGL     As Long = -1024            '/*E2 axis safety angle exceeded*/
Public Const ERR_W1_SAGL     As Long = -1025            '/*W1 axis safety angle exceeded*/
Public Const ERR_W2_SAGL     As Long = -1026            '/*W2 axis safety angle exceeded*/
                                                        '/*=== Ver.1.3 ====*/
Public Const ERR_S1_TAGL     As Long = -1030            '/*S1 axis target angle exceeded*/
Public Const ERR_S2_TAGL     As Long = -1031            '/*S2 axis target angle exceeded*/
Public Const ERR_S3_TAGL     As Long = -1032            '/*S3 axis target angle exceeded*/
Public Const ERR_E1_TAGL     As Long = -1033            '/*E1 axis target angle exceeded*/
Public Const ERR_E2_TAGL     As Long = -1034            '/*E2 axis target angle exceeded*/
Public Const ERR_W1_TAGL     As Long = -1035            '/*W1 axis target angle exceeded*/
Public Const ERR_W2_TAGL     As Long = -1036            '/*W2 axis target angle exceeded*/
                                                        '/*===============*/

Public Const ERR_LNK_CTL     As Long = -1039            '/*Unable to create teach point due to continuity restriction*/
Public Const ERR_MEM_FULL    As Long = -1040            '/*Failed to allocate memory space*/
Public Const ERR_MIS_COMD    As Long = -1041            '/*Prior procedure required before issuing this command*/
Public Const ERR_PB_CIR      As Long = -1042            '/*Incorrect circle or arc designation*/
Public Const ERR_PB_NEXT     As Long = -1043            '/*Next pointer not existing*/
Public Const ERR_PB_PRIV     As Long = -1044            '/*Previous pointer not existing*/
Public Const ERR_PB_END      As Long = -1045            '/*Playback data ended*/
Public Const ERR_PB_NULL     As Long = -1046            '/*Playback data not existing*/
Public Const ERR_PB_REFER    As Long = -1047            '/*Failed to find playback data*/
Public Const ERR_PB_REPLACE  As Long = -1048            '/*Accepted as replace command*/
Public Const ERR_PB_PANIC    As Long = -1049            '/*Pointer management accident*/

Public Const ERR_NOT_ENUGH   As Long = -1050            '/*Target value is out of control area. */
                                                        '/* (Arm length is not enough.)             */
Public Const ERR_MIS_PARAM   As Long = -1051            '/*Designated parameter value exceeded the setting range*/
Public Const ERR_NOA_DAT     As Long = -1060            '/*Designated NOA not appropriate Ver.1.3 */
Public Const ERR_PNT_ATR     As Long = -1061            '/Not available Ver.1.3 */
Public Const ERR_PTP_DAT     As Long = -1062            '/*Exceeding RMRC motion range Ver.1.3 */
Public Const ERR_CP_LOGGING  As Long = -1063            '/*Not allowed to use while in CP data acquisition Ver.1.3 */
Public Const ERR_FIFO_MAX    As Long = -1064            '/*Exceeded the maximum interpolation number Ver.1.3 */
Public Const ERR_FIFO_ARC    As Long = -1065            '/*Unable to generate circle or arc Ver.1.3 */
                                                        '/*=== Ver.1.3 ====*/
Public Const COVERS1         As Long = -1070            '/*S1 axis velocity angle exceeded*/
Public Const COVERS2         As Long = -1071            '/*S2 axis velocity angle exceeded*/
Public Const COVERS3         As Long = -1072            '/*S3 axis velocity angle exceeded*/
Public Const COVERE1         As Long = -1073            '/*E1 axis velocity angle exceeded/
Public Const COVERE2         As Long = -1074            '/*E2 axis velocity angle exceeded*/
Public Const COVERW1         As Long = -1075            '/*W1 axis velocity angle exceeded*/
Public Const COVERW2         As Long = -1076            '/*W2 axis velocity angle exceeded*/
                                                        '/*===============*/

'/*   EOperation continuity malfunction error: || iBrake-stop statusj*/

Public Const ERR_OVER900     As Long = -2017            '/*Arm length exceeded RMRC motion limitlength while in motion*/
                                                        
Public Const ERR_S1_AGL      As Long = -2020            '/*S1 axis angle exceeded*/
Public Const ERR_S2_AGL      As Long = -2021            '/*S2 axis angle exceeded*/
Public Const ERR_S3_AGL      As Long = -2022            '/*S3 axis angle exceeded*/
Public Const ERR_E1_AGL      As Long = -2023            '/*E1 axis angle exceeded*/
Public Const ERR_E2_AGL      As Long = -2024            '/*E2 axis angle exceeded*/
Public Const ERR_W1_AGL      As Long = -2025            '/*W1 axis angle exceeded*/
Public Const ERR_W2_AGL      As Long = -2026            '/*W2 axis angle exceeded*/
                                                        '/*=== Ver.1.3 ====*/
Public Const DOVERS1         As Long = -2030            '/*S1 axis direct control angle exceeded*/
Public Const DOVERS2         As Long = -2031            '/*S2 axis direct control angle exceeded*/
Public Const DOVERS3         As Long = -2032            '/*S3 axis direct control angle exceeded*/
Public Const DOVERE1         As Long = -2033            '/*E1 axis direct control angle exceeded*/
Public Const DOVERE2         As Long = -2034            '/*E2 axis direct control angle exceeded*/
Public Const DOVERW1         As Long = -2035            '/*W1 axis direct control angle exceeded*/
Public Const DOVERW2         As Long = -2036            '/*W2 axis direct control angle exceeded*/
                                                        '/*===============*/
Public Const ERR_CANT_MOVE As Long = -2051      '/*RMRC control is not allowed at the current position.*/
                                               
Public Const ERR_S1_REZ      As Long = -2060            '/*Anomalous S1 resolver deviation*/
Public Const ERR_S2_REZ      As Long = -2061            '/*Anomalous S2 resolver deviation*/
Public Const ERR_S3_REZ      As Long = -2062            '/*Anomalous S3 resolver deviation*/
Public Const ERR_E1_REZ      As Long = -2063            '/*Anomalous E1 resolver deviation*/
Public Const ERR_E2_REZ      As Long = -2064            '/*Anomalous E2 resolver deviation*/
Public Const ERR_W1_REZ      As Long = -2065            '/*Anomalous W1 resolver deviation*/
Public Const ERR_W2_REZ      As Long = -2066            '/*Anomalous W2 resolver deviation*/

'/*   <MEMO>Anomalous resolver deviation means when the resolver value inputted       */
'/*         at the previous time and the present time one exceed the allowable        */
'/*         range. (Incorrect loading, provokes missing data.)                        */

Public Const ERR_TIMEOUT     As Long = -2070            '/*Automatically stopped on account of exceeding surveillance time. Ver.1.3*/
Public Const ERR_SYNCOUT     As Long = -2071            '/*Not reaching the target value@Ver.1.3*/

Public Const ERR_SYNC_S1     As Long = -2080            '/*Anomalous S1 axis synchronization in axis control*/
Public Const ERR_SYNC_S2     As Long = -2081            '/*Anomalous S2 axis synchronization in axis control*/
Public Const ERR_SYNC_S3     As Long = -2082            '/*Anomalous S3 axis synchronization in axis control*/
Public Const ERR_SYNC_E1     As Long = -2083            '/*Anomalous E1 axis synchronization in axis control*/
Public Const ERR_SYNC_E2     As Long = -2084            '/*Anomalous E2 axis synchronization in axis control*/
Public Const ERR_SYNC_W1     As Long = -2085            '/*Anomalous W1 axis synchronization in axis control*/
Public Const ERR_SYNC_W2     As Long = -2086            '/*Anomalous W2 axis synchronization in axis control*/
Public Const ERR_RMRC_X      As Long = -2087            '/*Anomalous X axis synchronization in RMRC control*/
Public Const ERR_RMRC_Y      As Long = -2088            '/*Anomalous Y axis synchronization in RMRC control*/
Public Const ERR_RMRC_Z      As Long = -2089            '/*Anomalous Z axis synchronization in RMRC control*/
Public Const ERR_VELOCITY    As Long = -2090            '/*Anomalous velocity deviation*/
Public Const ERR_RMRC_YPR    As Long = -2091            '/*Anomalous tip orientation deviation in RMRC control*/

'/*
' <MEMO> Anomalous synchronization occurs when target and current value
'        deviation exceed the allowable range. (Arm is not moving or rather
'        delays motion.)
'*/

'/*      EFatal error || iControl stop statusj*/
Public Const ERR_POWER_ON    As Long = -3000            '/*control not started.*/
'/*
' <MEMO> After fatal error occurred without issuing control start command, if
'        other command is issued, this error occurs.
'*/
Public Const ERR_EM_CTL      As Long = -3001            '/*Emergency stop is pushed.*/
Public Const ERR_ARC_SEND    As Long = -3002            '/*Anomalous arc net communication Ver.1.3  */
Public Const ERR_FORCE_ON    As Long = -3010            '/*Not in force control  Ver.1.3 */
                                                        '/*====== Ver.1.3 ============*/
Public Const ERR_D1_B15      As Long = -3020
Public Const ERR_D1_B14      As Long = -3021
Public Const ERR_D1_B13      As Long = -3022
Public Const ERR_D1_B12      As Long = -3023
Public Const ERR_D1_B11      As Long = -3024
Public Const ERR_D1_B10      As Long = -3025
Public Const ERR_D1_B09      As Long = -3026
Public Const ERR_D1_B08      As Long = -3027
Public Const ERR_D1_B07      As Long = -3028
Public Const ERR_D1_B06      As Long = -3029
Public Const ERR_D1_B05      As Long = -3030
Public Const ERR_D1_B04      As Long = -3031
Public Const ERR_D1_B03      As Long = -3032
Public Const ERR_D1_B02      As Long = -3033
Public Const ERR_D1_B01      As Long = -3034
Public Const ERR_D1_B00      As Long = -3035
                              
Public Const ERR_D2_B15      As Long = -3040
Public Const ERR_D2_B14      As Long = -3041
Public Const ERR_D2_B13      As Long = -3042
Public Const ERR_D2_B12      As Long = -3043
Public Const ERR_D2_B11      As Long = -3044
Public Const ERR_D2_B10      As Long = -3045
Public Const ERR_D2_B09      As Long = -3046
Public Const ERR_D2_B08      As Long = -3047
Public Const ERR_D2_B07      As Long = -3048
Public Const ERR_D2_B06      As Long = -3049
Public Const ERR_D2_B05      As Long = -3050
Public Const ERR_D2_B04      As Long = -3051
Public Const ERR_D2_B03      As Long = -3052
Public Const ERR_D2_B02      As Long = -3053
Public Const ERR_D2_B01      As Long = -3054
Public Const ERR_D2_B00      As Long = -3055
                                                        '/*==========================*/

Public Const ERR_D1_COM      As Long = -3067
Public Const ERR_D2_COM      As Long = -3068
Public Const ERR_D3_COM      As Long = -3069
Public Const ERR_D4_COM      As Long = -3070

Public Const ERR_D11_STA     As Long = -3071            '/*Anomalous servo driver (S1) status*/
Public Const ERR_D12_STA     As Long = -3072            '/*Anomalous servo driver (S2) status*/
Public Const ERR_D21_STA     As Long = -3073            '/*Anomalous servo driver (S3) status*/
Public Const ERR_D22_STA     As Long = -3074            '/*Anomalous servo driver (E1) status*/
Public Const ERR_D31_STA     As Long = -3075            '/*Anomalous servo driver (E2) status*/
Public Const ERR_D32_STA     As Long = -3076            '/*Anomalous servo driver (W1) status*/
Public Const ERR_D41_STA     As Long = -3077            '/*Anomalous servo driver (W2) status*/

Public Const ERR_S_SUSPD     As Long = -3091            '/*Anomaly when issuing control (communication) start command*/
Public Const ERR_E_SUSPD     As Long = -3092            '/*Anomaly when issuing control (communication) end command*/
Public Const ERR_I_SUSPD     As Long = -3093            '/*Anomaly when issuing initialization command*/

'/*
' <MEMO> Anomalous control command issuing means when issuing command to
'        the servo driver, there is no response for a certain time. (Servo driver
'        is anomalous.)
'*/
Public Const ERR_D3_B15      As Long = -3120
Public Const ERR_D3_B14      As Long = -3121
Public Const ERR_D3_B13      As Long = -3122
Public Const ERR_D3_B12      As Long = -3123
Public Const ERR_D3_B11      As Long = -3124
Public Const ERR_D3_B10      As Long = -3125
Public Const ERR_D3_B09      As Long = -3126
Public Const ERR_D3_B08      As Long = -3127
Public Const ERR_D3_B07      As Long = -3128
Public Const ERR_D3_B06      As Long = -3129
Public Const ERR_D3_B05      As Long = -3130
Public Const ERR_D3_B04      As Long = -3131
Public Const ERR_D3_B03      As Long = -3132
Public Const ERR_D3_B02      As Long = -3133
Public Const ERR_D3_B01      As Long = -3134
Public Const ERR_D3_B00      As Long = -3135
                              
Public Const ERR_D4_B15      As Long = -3140
Public Const ERR_D4_B14      As Long = -3141
Public Const ERR_D4_B13      As Long = -3142
Public Const ERR_D4_B12      As Long = -3143
Public Const ERR_D4_B11      As Long = -3144
Public Const ERR_D4_B10      As Long = -3145
Public Const ERR_D4_B09      As Long = -3146
Public Const ERR_D4_B08      As Long = -3147
Public Const ERR_D4_B07      As Long = -3148
Public Const ERR_D4_B06      As Long = -3149
Public Const ERR_D4_B05      As Long = -3150
Public Const ERR_D4_B04      As Long = -3151
Public Const ERR_D4_B03      As Long = -3152
Public Const ERR_D4_B02      As Long = -3153
Public Const ERR_D4_B01      As Long = -3154
Public Const ERR_D4_B00      As Long = -3155
                                                       
Public Const ERR_D5_B15      As Long = -3220
Public Const ERR_D5_B14      As Long = -3221
Public Const ERR_D5_B13      As Long = -3222
Public Const ERR_D5_B12      As Long = -3223
Public Const ERR_D5_B11      As Long = -3224
Public Const ERR_D5_B10      As Long = -3225
Public Const ERR_D5_B09      As Long = -3226
Public Const ERR_D5_B08      As Long = -3227
Public Const ERR_D5_B07      As Long = -3228
Public Const ERR_D5_B06      As Long = -3229
Public Const ERR_D5_B05      As Long = -3230
Public Const ERR_D5_B04      As Long = -3231
Public Const ERR_D5_B03      As Long = -3232
Public Const ERR_D5_B02      As Long = -3233
Public Const ERR_D5_B01      As Long = -3234
Public Const ERR_D5_B00      As Long = -3235
                              
Public Const ERR_D6_B15      As Long = -3240
Public Const ERR_D6_B14      As Long = -3241
Public Const ERR_D6_B13      As Long = -3242
Public Const ERR_D6_B12      As Long = -3243
Public Const ERR_D6_B11      As Long = -3244
Public Const ERR_D6_B10      As Long = -3245
Public Const ERR_D6_B09      As Long = -3246
Public Const ERR_D6_B08      As Long = -3247
Public Const ERR_D6_B07      As Long = -3248
Public Const ERR_D6_B06      As Long = -3249
Public Const ERR_D6_B05      As Long = -3250
Public Const ERR_D6_B04      As Long = -3251
Public Const ERR_D6_B03      As Long = -3252
Public Const ERR_D6_B02      As Long = -3253
Public Const ERR_D6_B01      As Long = -3254
Public Const ERR_D6_B00      As Long = -3255
                                                       
Public Const ERR_D7_B15      As Long = -3320
Public Const ERR_D7_B14      As Long = -3321
Public Const ERR_D7_B13      As Long = -3322
Public Const ERR_D7_B12      As Long = -3323
Public Const ERR_D7_B11      As Long = -3324
Public Const ERR_D7_B10      As Long = -3325
Public Const ERR_D7_B09      As Long = -3326
Public Const ERR_D7_B08      As Long = -3327
Public Const ERR_D7_B07      As Long = -3328
Public Const ERR_D7_B06      As Long = -3329
Public Const ERR_D7_B05      As Long = -3330
Public Const ERR_D7_B04      As Long = -3331
Public Const ERR_D7_B03      As Long = -3332
Public Const ERR_D7_B02      As Long = -3333
Public Const ERR_D7_B01      As Long = -3334
Public Const ERR_D7_B00      As Long = -3335


Public Const ERR_BUS_TIMEOUT As Long = -4001
Public Const ERR_BOAD_ACFAIL As Long = -4002
Public Const ERR_WDT_TIMEOUT As Long = -4004
Public Const ERR_VME_SYSFAIL As Long = -4008
Public Const ERR_VME_ACFAIL  As Long = -4016
Public Const ERR_ABT_TIMEOUT As Long = -4032
Public Const ERR_VME_TIMEOUT As Long = -4064

